export declare type Patterns = {
    [name: string]: Pattern[];
};
export declare type PatternMatches = {
    [key: number]: string | Pattern | Pattern[];
};
export interface Pattern {
    name?: string;
    pattern?: RegExp;
    matches?: Pattern | PatternMatches;
    language?: string;
}
export interface Options {
    patterns: Patterns;
    inheritenceMap: {
        [name: string]: string;
    };
    aliases: {
        [name: string]: string;
    };
    globalClass: string;
    delay: number;
}
/**
 * Prism is a class used to highlight individual blocks of code
 */
declare class Prism {
    refract?: (code: string, language: string, patterns?: Pattern[]) => string;
    constructor(options: Options);
}
export default Prism;
