var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, LitElement, property } from '@polymer/lit-element';
import { color } from './rainbow.js';
export class RainbowCode extends LitElement {
    render() {
        let colorPromise = undefined;
        if (this.textContent !== null && this.language !== undefined) {
            colorPromise = (async () => {
                const tmp = document.createElement('template');
                const { result } = await color(this.textContent, this.language || 'generic');
                tmp.innerHTML = result;
                const node = document.importNode(tmp.content, true);
                return node;
            })();
        }
        return html `
      <style>
        code {
          white-space: pre;
        }
      </style>
      <link rel="stylesheet" href="${this.theme}">
      <pre>${colorPromise}</pre>
    `;
    }
    connectedCallback() {
        super.connectedCallback();
        this._mutationObserver =
            new MutationObserver((records) => { this.invalidate(); });
        this._mutationObserver.observe(this, {
            childList: true,
            characterData: true,
        });
    }
}
__decorate([
    property()
], RainbowCode.prototype, "language", void 0);
__decorate([
    property()
], RainbowCode.prototype, "theme", void 0);
customElements.define('rainbow-code', RainbowCode);
//# sourceMappingURL=rainbow-code.js.map