/**
 * Browser Only - Gets the language for this block of code
 */
export declare function getLanguageForBlock(block: Element): string | null;
/**
 * Determines if two different matches have complete overlap with each other
 *
 * @param start1   start position of existing match
 * @param end1     end position of existing match
 * @param start2   start position of new match
 * @param end2     end position of new match
 */
export declare function hasCompleteOverlap(start1: number, end1: number, start2: number, end2: number): boolean;
/**
 * Encodes < and > as html entities
 */
export declare function htmlEntities(code: string): string;
/**
 * Finds out the position of group match for a regular expression
 *
 * @see
 * http://stackoverflow.com/questions/1985594/how-to-find-index-of-groups-in-match
 */
export declare function indexOfGroup(match: RegExpMatchArray, groupNumber: number): number;
/**
 * Determines if a new match intersects with an existing one
 *
 * @param start1    start position of existing match
 * @param end1      end position of existing match
 * @param start2    start position of new match
 * @param end2      end position of new match
 */
export declare function intersects(start1: number, end1: number, start2: number, end2: number): boolean;
/**
 * Sorts an objects keys by index descending
 */
export declare function keys(object: any): any[];
/**
 * Substring replace call to replace part of a string at a certain position
 *
 * @param position         the position where the replacement
 *                                  should happen
 * @param replace          the text we want to replace
 * @param replaceWith      the text we want to replace it with
 * @param code             the code we are doing the replacing in
 */
export declare function replaceAtPosition(position: number, replace: string, replaceWith: string, code: string): string;
